package supperSlonic.emrWorkflow;

import com.amazonaws.services.elasticmapreduce.AmazonElasticMapReduceClient;
import com.amazonaws.services.elasticmapreduce.model.RunJobFlowRequest;
import com.amazonaws.services.elasticmapreduce.model.RunJobFlowResult;

import supperSlonic.emrWorkflow.Builders.JobFlowBuilder;

public class JobInvoker
{
	public static String startJob(JobFlowContext jobFlowContext)
	{
		JobFlowBuilder builder = new JobFlowBuilder(jobFlowContext);
		RunJobFlowRequest jobFlowRequest = builder.build();
		
		AmazonElasticMapReduceClient emrClient = new AmazonElasticMapReduceClient(jobFlowContext.getCredentials());
		RunJobFlowResult result = emrClient.runJobFlow(jobFlowRequest);
		String jobFlowId = result.getJobFlowId();
		
		return jobFlowId;
	}
	
	/*
	public static void waiteResult(String jobFlowId, JobFlowContext jobFlowContext) throws InterruptedException
	{
		int currentStepNum = 0;
		
		AmazonElasticMapReduceClient emrClient = new AmazonElasticMapReduceClient(jobFlowContext.getCredentials());
		DescribeJobFlowsRequest describeJobFlowsRequest = new DescribeJobFlowsRequest();
		describeJobFlowsRequest.getJobFlowIds().add(jobFlowId);
		
		
		while(true)
		{
			DescribeJobFlowsResult result = emrClient.describeJobFlows(describeJobFlowsRequest);
			List<StepDetail> steps = result.getJobFlows().get(0).getSteps();
			StepExecutionStatusDetail status = steps.get(currentStepNum).getExecutionStatusDetail();
			
			System.out.println(status.getState());
			if(status.getState().equals("FAILED"))
				return;
			else if(status.getState().equals("COMPLETED"))
			{
				currentStepNum++;
			}
			
			if(currentStepNum == steps.size())
				return;
			
			Thread.sleep(30000);
		}
	}
	
	public static void fixStep(String jobFlowId, JobFlowContext jobFlowContext)
	{
		JobFlowBuilder builder = new JobFlowBuilder(jobFlowContext);
		RunJobFlowRequest jobFlowRequest = builder.build();
		
		StepConfig stepConfig = jobFlowRequest.getSteps().get(1);
		stepConfig.getHadoopJarStep().getArgs().add("s3://3d-geometry-mapreduce/gml/buildings.gml");
		AddJobFlowStepsRequest request1 = new AddJobFlowStepsRequest(jobFlowId);
		request1.getSteps().add(stepConfig);
		
		AmazonElasticMapReduceClient emrClient = new AmazonElasticMapReduceClient(jobFlowContext.getCredentials());
		emrClient.addJobFlowSteps(request1);
	}*/
}
